#include <glide.h>

// Just some datatype I use to

// Store vertexinformation Glide needs when renedering a triangle
typedef struct grVertex_type 
{	FxFloat x,y,z;
	FxFloat oow;
	FxFloat r,g,b;
} grVertex, *grVertex_ptr;

// Store a Vertex
typedef struct D3Vertex_type 
{	FxFloat x,y,z;
	FxFloat r,g,b;
} D3Vertex, *D3Vertex_ptr;

// Store a normal
typedef struct Normal_type 
{	FxFloat x,y,z;
} Normal, *Normal_ptr;

// Store a Face
typedef struct Face_type 
{	int a,b,c;
} Face, *Face_ptr;

// Store a 3D Object
typedef struct D3Object_type
{	int Id;								// Object id number
	int NumVertices;					// Number of Vertices
	int NumFaces;						// Number of Faces
	D3Vertex_ptr Vertices_local;		// Local Coordinate information
	D3Vertex_ptr Vertices_world;		// Coordinate information after rotation
	grVertex_ptr Vertices_screen;		// Screen Coordinate information
	Normal_ptr   Vertices_normalStat;	// Here we store our precalculated vertexnormals
	Face_ptr     Faces;					// Face information
	D3Vertex	 SpotlightStat;			// Spotlight position
	D3Vertex	 Spotlight;				// Spotlight position after rotation
} D3Object, *D3Object_ptr;

// Simple funtion to set the vertexlayout
void SetVertexLayout()
{	grVertexLayout(GR_PARAM_XY, 0,  GR_PARAM_ENABLE);
	grVertexLayout(GR_PARAM_Q,  12, GR_PARAM_ENABLE);
	grVertexLayout(GR_PARAM_RGB,16, GR_PARAM_ENABLE);

}